import java.io.File;
import java.io.FileNotFoundException;
import java.util.ArrayList;
import java.util.Scanner;

public class Parser {

	// Index of the current assembly command in the commands ArrayList.  It is
	// initialized via reset() to -1 to match the Parser's description in the
	// textbook.  Namely, that advance() be called on the Parser _before_ performing
	// any actual parsing.
	private int index;
	private ArrayList<String> commands;

	// The constructor is complete.  You should not need to modify it.
	
	public Parser(String asmFile) {
		commands = new ArrayList<String>();
		reset();
		fill(asmFile);
	}

	// Reset the parser.  Used prior to the second pass.
	// This method is complete.
	public void reset() {
		index = -1;
	}


	// This method is complete.
	public boolean hasMoreCommands() {
		return index < commands.size() - 1;
	}

	// This method is complete.
	public void advance() {
		index++;
	}

	public CommandType commandType() {
		char c = commands.get(index).charAt(0);

		// Complete this method.  The return is present simply to satisfy the compiler.
		
		return CommandType.C_COMMAND;
	}

	public String symbol() {
		CommandType ct = commandType();
		String current = commands.get(index);

		// Complete this method.  The return is present simply to satisfy the compiler.

		return "";
	}

	public String dest() {
		String current = commands.get(index);
		int index = current.indexOf('=');

		// Complete this method.  The return is present simply to satisfy the compiler.
		
		return "";
	}

	public String comp() {
		String current = commands.get(index);
		int begin = current.indexOf('=');
		int end = current.indexOf(';');

		// Complete this method.  The return is present simply to satisfy the compiler.

		return "";
	}

	public String jump() {
		String current = commands.get(index);
		int index = current.indexOf(';');

		// Complete this method.  The return is present simply to satisfy the compiler.

		return "";
	}

	// Fill the commands list with assembly commands.
	// Do NOT modify this method.
	private void fill(String src) {
		Scanner scanner;
		String line;
		int index;

		try {
			scanner = new Scanner(new File(src));

			while (scanner.hasNextLine()) {
				line = scanner.nextLine();
				// Remove all whitespace characters
				line = line.replaceAll("\\s", "");
				// Remove comments
				index = line.indexOf("//");
				if (index != -1)
					line = line.substring(0, index);
				// At this point, the line might be empty.
				// If it isn't empty, add it to the commands list.
				if (line.length() > 0) {
					commands.add(line);
					// Uncomment the following Java statement to see the
					// assembly lines being stored in the commands ArrayList.
					//System.out.println(line);
				}
			}
		} catch (FileNotFoundException e) {
			e.printStackTrace();
			System.exit(1);
		}

	}
}
